#ifndef _AC_DIRENT_H
#define _AC_DIRENT_H

#include "ac.h"
#include "ac_stdio.h"
#include <sys/types.h>
#include <sys/dirent.h>

#define AC_DIRENT_FLAG_LOCAL	(1 << 0)

struct htmlentry {
	struct htmlentry *next;
	char name[NAME_MAX];
	char url[NAME_MAX];
};

struct htmlentrylist {
	struct htmlentry *cur;
	struct htmlentry *head;
};

/*
struct ac_dirent {
	ino_t d_ino;
	char  d_name[NAME_MAX];
};
*/

#define ac_dirent dirent

struct sDIR {
	struct ac_dirent *curdirent;
	union {
		struct htmlentrylist *list;
		DIR *localdir;
	};
	int charsstored;
	int curchar;
	int readnecessary;
	char *url;
	AC_FILE *f;
	char *content;
	int flags;
};

typedef struct sDIR AC_DIR;

AC_DIR *ac_opendir(const char *url);
struct ac_dirent *ac_readdir(AC_DIR *d);
int ac_closedir(AC_DIR *d);

#ifdef _USE_AC
#define opendir ac_opendir
#define readdir ac_readdir
#define closedir ac_closedir
#define DIR AC_DIR
#endif

#endif
